#include <Array.au3>
#include <MsgBoxConstants.au3>

Example()

Func Example()
	; Erstellt ein 1D Array zum anzeigen
	Local $aArray_1D[5] = ["Item 0", "Item 1", "Ein breites Item 2 um die Spaltenanpassung zu zeigen", "Item 3", "Item 4"]

	_ArrayDisplay($aArray_1D, "1D Anzeige")
	_ArrayDisplay($aArray_1D, "1D Anzeige gedreht - nur 'Copy' Buttons", Default, 1 + 16) ; Keine Buttons werden angezeigt

	; Erstellt ein 2D Array zum anzeigen
	Local $aArray_2D[75][255]
	For $i = 0 To UBound($aArray_2D) - 1
		For $j = 0 To UBound($aArray_2D, 2) - 1
			$aArray_2D[$i][$j] = "Item " & StringFormat("%02i", $i) & StringFormat("%02i", $j)
		Next
	Next

	_ArrayDisplay($aArray_2D, "2D Anzeige") ; Es ist zu beachten, dass die Spalten gekürzt sind
	_ArrayDisplay($aArray_2D, "2D Anzeige gedreht", Default, 1) ; Es ist zu beachten, dass alle Array-Ele,ent angezeigt werden

	ReDim $aArray_2D[20][10]
	$aArray_2D[5][5] = "Ein breites Item um die Spaltenanpassung zu zeigen"
	_ArrayDisplay($aArray_2D, "Angepasste Spalte - eigene Spaltennamens - alternative Zeilenfarben - keine Buttons oder 'Row' column", Default, 32 + 64, Default, "AA|BB|CC|DD|EE|FF|GG|HH|II|JJ", Default, 0xDDFFDD)

	; Verbindet die User-Funktion mit einer Variable um diese als Parameter zu übergeben
	Local $hUserFunction = _UserFunc

	$aArray_2D[5][5] = "rechtsbündige Spaltenausrichtung"
	_ArrayDisplay($aArray_2D, "Bereich gesetzt - rechtsbündig - Spaltenbreite kopieren - Benutzerfunktion", "3:7|4:9", 2, 15, "AA|BB|CC|DD|EE|FF", Default, Default, $hUserFunction)
	_ArrayDisplay($aArray_2D, "Bereich gesetzt - rechtsbündig - Spaltenbreite kopieren - vertauscht", "3:7|4:9", 3, 15, "AA|BB|CC|DD|EE|FF") ; Note no col names as transposed

	; Erstellt eine nicht-Array Variable um einen Fehler zu erzwingen - eine MsgBox wird angezeigt, da $iFlags gesetzt ist
	Local $vVar = 0
	_ArrayDisplay($vVar, "MsgBox bei einem Fehler", Default, 8)

EndFunc   ;==>Example

; Es ist zu beachten, dass die Benutzerfunktion 2 Parameter haben muss, auch wenn man nicht vorhat beide zu verwenden
Func _UserFunc($aArray_2D, $aSelected)

	; Falls kein Parameter verwendet werden soll, sollte die folgende Zeile eingefügt werden, damit Au3Check keine Warnung ausgibt
	#forceref $aArray_2D

	_ArrayDisplay($aSelected, "Ausgewählte Spalten")

EndFunc   ;==>_UserFunc
