#include <ComboConstants.au3>
#include <Crypt.au3>
#include <GUIConstantsEx.au3>
#include <MsgBoxConstants.au3>
#include <StringConstants.au3>

Example()

Func Example()
	Local $iAlgorithm = $CALG_RC4

	Local $hGui = GUICreate("Datei Verschlüsseln", 425, 100)
	Local $idSourceInput = GUICtrlCreateInput("", 5, 5, 200, 20)
	Local $idSourceBrowse = GUICtrlCreateButton("...", 210, 5, 35, 20)

	Local $idDestinationInput = GUICtrlCreateInput("", 5, 30, 200, 20)
	Local $idDestinationBrowse = GUICtrlCreateButton("...", 210, 30, 35, 20)

	GUICtrlCreateLabel("Passwort:", 5, 60, 200, 20)
	Local $idPasswordInput = GUICtrlCreateInput("", 5, 75, 200, 20)

	Local $idCombo = GUICtrlCreateCombo("", 210, 75, 100, 20, $CBS_DROPDOWNLIST)
	GUICtrlSetData($idCombo, "3DES|AES (128bit)|AES (192bit)|AES (256bit)|DES|RC2|RC4", "RC4")
	Local $idEncrypt = GUICtrlCreateButton("Verschlüsseln", 355, 70, 65, 25)
	GUISetState(@SW_SHOW, $hGui)

	Local $sDestinationRead = "", $sFilePath = "", $sPasswordRead = "", $sSourceRead = ""
	While 1
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE
				ExitLoop

			Case $idSourceBrowse
				$sFilePath = FileOpenDialog("Datei zum entschlüsseln auswählen.", "", "Alle Dateien (*.*)") ; Datei zum Entschlüsseln auswählen.
				If @error Then
					ContinueLoop
				EndIf
				GUICtrlSetData($idSourceInput, $sFilePath) ; Pfad in der Inputbox anzeigen.

			Case $idDestinationBrowse
				$sFilePath = FileSaveDialog("Datei speichern als ...", "", "Alle Dateien (*.*)") ; Datei auswählen, um die entschlüsselten Daten zu speichern.
				If @error Then
					ContinueLoop
				EndIf
				GUICtrlSetData($idDestinationInput, $sFilePath) ; Pfad in der Inputbox anzeigen.

			Case $idCombo ; Status der Combobox abfragen und die ausgewählte Verschlüsselungsmethode empfangen.
				Switch GUICtrlRead($idCombo) ; Auslesen der Combobox.
					Case "3DES"
						$iAlgorithm = $CALG_3DES

					Case "AES (128bit)"
						$iAlgorithm = $CALG_AES_128

					Case "AES (192bit)"
						$iAlgorithm = $CALG_AES_192

					Case "AES (256bit)"
						$iAlgorithm = $CALG_AES_256

					Case "DES"
						$iAlgorithm = $CALG_DES

					Case "RC2"
						$iAlgorithm = $CALG_RC2

					Case "RC4"
						$iAlgorithm = $CALG_RC4

				EndSwitch

			Case $idEncrypt
				$sSourceRead = GUICtrlRead($idSourceInput) ; Quelldateipfad einlesen.
				$sDestinationRead = GUICtrlRead($idDestinationInput) ; Zieldateipfad einlesen.
				$sPasswordRead = GUICtrlRead($idPasswordInput) ; Passwort-Input auslesen.
				If StringStripWS($sSourceRead, $STR_STRIPALL) <> "" And StringStripWS($sDestinationRead, $STR_STRIPALL) <> "" And StringStripWS($sPasswordRead, $STR_STRIPALL) <> "" And FileExists($sSourceRead) Then ; Prüfen ob eine Datei und ein Passwort gegeben sind.
					If _Crypt_EncryptFile($sSourceRead, $sDestinationRead, $sPasswordRead, $iAlgorithm) Then ; Verschlüsseln der Datei.
						MsgBox($MB_SYSTEMMODAL, "Erfolgreich", "Operation erfolgreich")
					Else
						Switch @error
							Case 1
								MsgBox(16, "Fehler", "Erstellen des Schlüssels fehlgeschlagen.")
							Case 2
								MsgBox(16, "Fehler", "Quelldatei konnte nicht geöffnet werden.")
							Case 3
								MsgBox(16, "Fehler", "Zieldatei konnte nicht geöffnet werden.")
							Case 4 Or 5
								MsgBox(16, "Fehler", "Allgemeiner Entschlüsselungsfehler.")
						EndSwitch
					EndIf
				Else
					MsgBox($MB_SYSTEMMODAL, "Fehler", "Die angegebenen Information sind fehlerhaft.")
				EndIf
		EndSwitch
	WEnd

	GUIDelete($hGui) ; Löscht die vorherige GUI und alle Controls.
EndFunc   ;==>Example
