#include <ComboConstants.au3>
#include <Crypt.au3>
#include <GUIConstantsEx.au3>
#include <StringConstants.au3>

Example()

Func Example()
	Local $iAlgorithm = $CALG_SHA1

	Local $hGui = GUICreate("Datei Hash", 425, 70)
	Local $idInput = GUICtrlCreateInput(@ScriptFullPath, 5, 5, 200, 20)
	Local $idBrowse = GUICtrlCreateButton("...", 210, 5, 35, 20)
	Local $idCombo = GUICtrlCreateCombo("", 250, 5, 100, 20, $CBS_DROPDOWNLIST)
	GUICtrlSetData($idCombo, "MD2|MD4|MD5|SHA1", "SHA1")
	Local $idCalculate = GUICtrlCreateButton("Berechnen", 355, 40, 65, 25)
	Local $idHashLabel = GUICtrlCreateLabel("Hash", 5, 50, 350, 25)
	GUISetState(@SW_SHOW, $hGui)

	_Crypt_Startup() ; Startet die Crypt-Bibliothek um die Performance zu optimieren.

	Local $dHash = 0, _
			$sRead = ""
	While 1
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE
				ExitLoop

			Case $idBrowse
				Local $sFilePath = FileOpenDialog("Öffnen...", "", "Alle Dateien (*.*)") ; Datei zum hashen auswählen.
				If @error Then
					ContinueLoop
				EndIf
				GUICtrlSetData($idInput, $sFilePath) ; Dateipfad in Inputbox ausgeben.
				GUICtrlSetData($idHashLabel, "Hash") ; Label für Hash-Ouput zurücksetzen.

			Case $idCombo ; Status der Combobox abfragen und gewählte Methode empfangen.
				Switch GUICtrlRead($idCombo) ; Combobox auslesen.
					Case "MD2"
						$iAlgorithm = $CALG_MD2

					Case "MD4"
						$iAlgorithm = $CALG_MD4

					Case "MD5"
						$iAlgorithm = $CALG_MD5

					Case "SHA1"
						$iAlgorithm = $CALG_SHA1

				EndSwitch

			Case $idCalculate
				$sRead = GUICtrlRead($idInput)
				If StringStripWS($sRead, $STR_STRIPALL) <> "" And FileExists($sRead) Then ; Prüfen ob eine Datei angegeben ist.
					$dHash = _Crypt_HashFile($sRead, $iAlgorithm) ; Hash der Datei erstellen.
					GUICtrlSetData($idHashLabel, $dHash) ; Hash im Label ausgeben.
				EndIf
		EndSwitch
	WEnd

	GUIDelete($hGui) ; Löscht die vorherige GUI und alle Controls.
	_Crypt_Shutdown() ; Beendet die Crypt-Bibliothek.
EndFunc   ;==>Example
